#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "mysh.h"
#include "callbacks.h"
#include "interface.h"
#include "support.h"

//extern GtkWidget *g_one_node_d;
extern GtkWidget *g_one_node;
extern GtkWidget *g_mainWin;
extern GtkWidget *g_setupDialog;
extern GtkWidget *g_confWin;
extern int g_interval;

/******mainWin**********************************************/

/*mainWin$B$,>C$5$l$?;~$N=hM}(B*/
gboolean on_mainWin_delete_event(GtkWidget *widget, GdkEvent *event,
				 gpointer user_data){
  gtk_main_quit();
  return FALSE;
}

/*mainWin$B$,2u$5$l$?;~$N=hM}(B*/
gboolean on_mainWin_destroy_event(GtkWidget *widget, GdkEvent *event,
				  gpointer  user_data){
  gtk_main_quit();
  return FALSE;
}
/*file$B$,A*$P$l$?;~$N=hM}(B*/
void on_file_activate(GtkMenuItem *menuitem, gpointer user_data){
}

/*quit$B$,A*$P$l$?;~$N=hM}(B*/
void on_quit_activate(GtkMenuItem *menuitem,gpointer  user_data){
  gtk_main_quit();
}

/*$B%;%C%H%"%C%W$N;~$N=hM}(B*/
void on_setup_activate(GtkMenuItem *menuitem, gpointer user_data){
  g_setupDialog = create_setupDialog();
  gtk_widget_show (g_setupDialog);
}

/*about$B$,A*$P$l$?;~$N=hM}(B*/
void on_about_activate (GtkMenuItem *menuitem, gpointer user_data){
  GtkWidget *aboutDialog;
  aboutDialog = create_aboutDialog();
  gtk_widget_show(aboutDialog);
}
/*text_feild$B$,JQ$o$C$?;~$N=hM}(B*/
void on_search_text_changed(GtkEditable *editable, gpointer user_data){
  GtkWidget *search_bar;
  search_bar = lookup_widget(GTK_WIDGET(g_mainWin), "search_text");
  search_word = gtk_editable_get_chars(GTK_EDITABLE(search_bar),
				       (gint)0,(gint)-1);
  printf("Search_word is %s\n" ,search_word);
  
  reset_MR_list();  
  //  g_free(search_word);
  return;
}

/*mainWin$B$N(BMRlist$B$,A*$P$l$?;~$N=hM}(B*/
void on_MRlist_select_row(GtkCList *clist, gint row, gint column,
			  GdkEvent *event, gpointer user_data){

  //$BA*Br$5$l$?%N!<%I$NEPO?(B
  selected_MR[MR_item_binding(row)]=1;
  
  target_now = MR_item_binding(row);//$B<B:]$N(Brow$B$+$i%?!<%2%C%H$NHV9f$rCN$k(B
  g_row = row;
  
  if(g_one_node==NULL){      //one_node$B%Q%M%k$,$J$+$C$?$i:n$k!#(B
    g_one_node = create_one_node();
    gtk_widget_show(g_one_node);
  }
  reset_MR_status();
  
  return;
}

/*mainWin$B$N(BMRlist$B$,A*Br$,2r=|$5$l$?;~$N=hM}(B*/
void on_MRlist_unselect_row(GtkCList *clist,gint row, gint column,
			    GdkEvent *event,gpointer  user_data){
  //$BA*Br$5$l$?%N!<%I$NEPO?Ku>C(B
  selected_MR[MR_item_binding(row)]=0;
  return;
}

/*combo$B$NA*Br$,JQ$o$C$?;~(B*/
void on_search_combo_changed(GtkEditable *editable, gpointer user_data){
  reset_MR_list();
}

/*$B0lHV2<$N(Bconfigure_bottun$B$,2!$5$l$?;~(B*/
void on_configure_bottun_clicked(GtkButton *button, gpointer user_data){
  
  GtkWidget *MR_list;
  char buf[MAX], *item[1];  
  int i;    
  g_confWin = create_confWin();
  gtk_widget_show (g_confWin);
  MR_list= lookup_widget(GTK_WIDGET(g_confWin), "MR_list"); 
  
  for(i=0 ; i<MAX_NODE ; i++){
    if(selected_MR[i]==1){    //$BA*Br$5$l$F$$$?$i2C$($k(B
      item[0]=mr[i].host_name;
      gtk_clist_append(MR_list, item); 
    }
    //confWin$B$N$?$a$KA*Br>pJs$rJ]B8$9$k(B
    selected_MR_on_confWin[i] = selected_MR[i];  
  }
  gtk_clist_select_all(MR_list); 
  
}


/******aboutDialog*****************************************/


/*aboutDialog$B$G(BOK$B$,2!$5$l$?;~$N=hM}(B */
void on_ok_about_clicked(GtkButton *button, gpointer user_data){
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}


/******one_node*******************************************/

/*one_node$B$,>C$5$l$?;~$N=hM}(B*/
gboolean on_one_node_delete_event(GtkWidget *widget,GdkEvent *event,
				  gpointer user_data){
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(widget)));
  g_one_node=NULL;
  return FALSE;
}

/*one_node$B$,>C$5$l$?;~$N=hM}(B*/

gboolean on_one_node_destroy_event(GtkWidget *widget,GdkEvent *event,
				   gpointer user_data){
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(widget)));
  g_one_node=NULL;
  return FALSE;
}

/*show [BUL @ MR]$B$,2!$5$l$?;~$N=hM}(B*/
void on_show_bul_clicked(GtkButton *button,gpointer user_data){
  reset_MR_status();
}

/*show [BC @ HA]$B$,2!$5$l$?;~(B*/
void on_show_bc_clicked(GtkButton *button,gpointer user_data){
  reset_HA_status();
}

/*Dell BUL @ MR$B$,2!$5$l$?;~(B*/
void on_del_bul_clicked(GtkButton *button,gpointer user_data){
  del_BUL(target_now);
}

/*dell BC @ HA$B$,2!$5$l$?;~$N=hM}(B*/
void on_del_bc_clicked (GtkButton *button,gpointer user_data){
  del_BC(target_now);
}

/*one_node$B$N(Bquit$B$,2!$5$l$?;~$N=hM}(B*/
void on_quit_clicked(GtkButton *button,gpointer user_data){
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
  g_one_node = NULL;
}

/***********setupDialog*****************************/

/*setupDialog$B$N(Bcancel$B%\%?%s(B*/
void on_cancelbutton1_clicked(GtkButton *button,gpointer user_data){
    gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}

/*setupDialog$B$N(BOK$B%\%?%s(B*/
void on_okbutton2_clicked(GtkButton *button,gpointer user_data){
  GtkWidget *spin = lookup_widget(GTK_WIDGET(button),"interval");
  g_interval = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin));
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}

/********* configure panel ****************************/
/* configure panel$B$,>C$5$l$?;~$N=hM}(B*/
gboolean on_confWin_delete_event (GtkWidget *widget,GdkEvent *event,
				  gpointer         user_data){
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(widget)));
  return FALSE;
}

/* configure panel$B$,2u$5$l$?;~$N=hM}(B*/
gboolean on_confWin_destroy_event(GtkWidget *widget,GdkEvent *event,
				  gpointer         user_data){
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(widget)));
  return FALSE;
}

/*$B%-%c%s%;%k$,2!$5$l$?;~$N=hM}(B*/
void on_confWin_cancel_clicked(GtkButton *button,gpointer user_data){
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}

/*O.K$B$,2!$5$l$?;~$N=hM}(B*/
void on_confWin_ok_clicked(GtkButton *button, gpointer user_data){
  int i, primary=0;   //primary 1.$B%A%'%C%/$,F~$C$F$$$k!"(B0.$BF~$C$F$$$J$$(B 
  char *buf;   //$B%$%s%?!<%U%'%$%9$NL>A0$rF~$l$k!J;H$$2s$9!K(B
  
  GtkWidget *del_bc_check,                   //--HA--
    *start_ha, *stop_ha, *if_name_start_ha,  //radio
    *interval_spin,                          //--MR--
    *rtsol_check, *if_name_rtsol,            //rtsol
    *del_bul_check,                           //del_bul_check
    *add_if, *change_if, *del_if, *if_name_add, *primary_check; //radio
  
  del_bc_check = lookup_widget(GTK_WIDGET(g_confWin),"del_bc_check");
  start_ha = lookup_widget(GTK_WIDGET(g_confWin),"start_HA");  
  stop_ha = lookup_widget(GTK_WIDGET(g_confWin),"stop_HA"); 
  if_name_start_ha=lookup_widget(GTK_WIDGET(g_confWin),"if_name_start_ha");   
  interval_spin = lookup_widget(GTK_WIDGET(g_confWin),"interval_spin");
  rtsol_check = lookup_widget(GTK_WIDGET(g_confWin),"rtsol_check");
  if_name_rtsol = lookup_widget(GTK_WIDGET(g_confWin),"if_name_rtsol");  
  del_bul_check = lookup_widget(GTK_WIDGET(g_confWin),"del_bul_check");  
  add_if = lookup_widget(GTK_WIDGET(g_confWin),"add_if"); 
  change_if = lookup_widget(GTK_WIDGET(g_confWin),"change_if"); 
  del_if = lookup_widget(GTK_WIDGET(g_confWin),"del_if"); 
  if_name_add = lookup_widget(GTK_WIDGET(g_confWin),"if_name_add"); 
  primary_check = lookup_widget(GTK_WIDGET(g_confWin),"primary_check"); 
  
  //Home Agent $B$N(B Binding Cache$B$r>C$9(B
  if(gtk_toggle_button_get_active (del_bc_check)==TRUE){  //del_bc$B$,(BON$B$@$C$?$i(B
    printf("--delete Binding Cache----------------------------\n");
    for(i=0 ; i<MAX_NODE; i++){
      if(selected_MR_on_confWin[i] == 1){    //$BA*$P$l$?$b$N$r(B
	del_BC(i);                           //BC$B$r$1$9(B
      }
    }
  }
  
  //Home Agent $B$r(B Start / Stop $B$5$;$k(B
  buf = gtk_editable_get_chars(GTK_EDITABLE(if_name_start_ha)
			       ,(gint)0,(gint)-1);
  if(gtk_toggle_button_get_active(start_ha)==TRUE){     //Start HA$B$@$C$?$i(B
    printf("\n--Start Home Agent------------------------------\n");
    for(i=0 ; i<MAX_NODE; i++){
      if(selected_MR_on_confWin[i] == 1){    //$BA*$P$l$?$b$N$r(B
	start_HA(i, buf);
      }
    }
  }else if(gtk_toggle_button_get_active(stop_ha)==TRUE){
    printf("\n--Start Home Agent------------------------------\n");
    for(i=0 ; i<MAX_NODE; i++){
      if(selected_MR_on_confWin[i] == 1){    //$BA*$P$l$?$b$N$r(B
	stop_HA(i, buf);
      }
    }
  }

  //Mobile Router $B$N(B Binding Update List $B$r>C$9(B
  if(gtk_toggle_button_get_active (del_bul_check)==TRUE){  //del_bul$B$,(BON$B$@$C$?$i(B
    printf("\n--delete Binding Update List----------------------\n");
    for(i=0 ; i<MAX_NODE; i++){
      if(selected_MR_on_confWin[i] == 1){    //$BA*$P$l$?$b$N$r(B
	del_BUL(i);                           //BUL$B$r$1$9(B
      }
    }
  }
  
  // Mobile Router $B>e$G(B rtsol $B$r<B9T$9$k(B
  //if_name_rtsol
  buf = gtk_editable_get_chars(GTK_EDITABLE(if_name_rtsol),(gint)0,(gint)-1);
  // rtsol$B%A%'%C%/%\%?%s$,(BON$B$@$C$?$i(B
  if( gtk_toggle_button_get_active (rtsol_check)==TRUE){
    printf("\n--rtsol command----------------------------------\n");
    //rtsol $B$r<B9T(B
    for(i=0 ; i<MAX_NODE; i++){
      if(selected_MR_on_confWin[i] == 1){    //$BA*$P$l$?$b$N$r(B
	rtsol_comand(i , buf);               // rtsol $B$r<B9T(B
      }
    }
  }
  
  //mobileip$B$K;H$&%$%s%?!<%U%'%$%9$r2C$($k(B
  buf = gtk_editable_get_chars(GTK_EDITABLE(if_name_add),(gint)0,(gint)-1);
  
  if(gtk_toggle_button_get_active (primary_check)==TRUE){
    primary = 1;                 //$B%W%i%$%^%j$K%A%'%C%/$,F~$C$F$$$k(B
  }else{
    primary = 0;                 //$B%W%i%$%^%j$K%A%'%C%/$,F~$C$F$$$J$$(B
  }
  
  if(gtk_toggle_button_get_active (add_if)==TRUE){    //Add$B$,A*$P$l$F$$$k(B
    printf("\n--Add network interface to mobileip0------------\n");
    for(i=0 ; i<MAX_NODE; i++){
      if(selected_MR_on_confWin[i] == 1){    //$BA*$P$l$?$b$N$r(B
	add_interface(i , buf, primary);       // interface$B$r2C$($k(B
      }
    }
  }else if(gtk_toggle_button_get_active(change_if)==TRUE){ //change$B$,A*$P$l$$$k(B 
    printf("\n--Change network interface to mobileip0---------\n");
    for(i=0 ; i<MAX_NODE; i++){
      if(selected_MR_on_confWin[i] == 1){    //$BA*$P$l$?$b$N$r(B
	change_interface(i , buf, primary);       // interface$B$rJQ99$9$k(B
      }
    }
  }else if(gtk_toggle_button_get_active(del_if)==TRUE){ //delete$B$,A*$P$l$$$k(B 
    printf("\n--Delete network interface to mobileip0---------\n");
    for(i=0 ; i<MAX_NODE; i++){
      if(selected_MR_on_confWin[i] == 1){    //$BA*$P$l$?$b$N$r(B
	del_interface(i , buf);         // interface$B$r>C$9(B
      }
    }
  }
  
    
  
  
  
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}


