#include "mysh.h"

/* $B%3%^%s%I$N0z?t$r8+6K$a$k(B*/
void parse(char *com, char *args[]){
  int i=0;

  while( *com != NULL ){
    /* truncate leading spaces */
    while( *com == ' ' || *com == '\t' ){
      *com = '\0';
      com++;
    }
    args[i] = com;
    if(i >= MAX){
      break;
    }
    i++;
    /* skip this argument */
    while( *com != ' ' && *com != '\t'
           && *com != '\0' ){
      com++;
    }
  }
  args[i] = NULL;
  return;
}

//$BJ8;z$r<u$1<h$C$F<B9T!"$=$l$r(Binfo[1024]$B$K(B
void ExecCommand(char *line){
  char *args[1024],command[ARGS];
  int comlen;
  int status;
  pid_t pid, cpid;
  int fd[2];
  
  comlen = strlen(line);
  strncpy(command,line,comlen);
  command[comlen] = '\0';
  //debug
  // printf("%s\n",command);

  parse(command,args);
  
  if(pipe(fd)!=0){   //$B%Q%$%W$r:n$k(B
    perror("pipe");
    exit(1);
  }
  
  pid = fork(); 
  if(pid < 0){
    perror("fork");
  }
  if( pid == 0 ){ //child 
    close(fd[1]);     //$B$$$i$J$$J}$r%/%m!<%:(B
    dup2(fd[0], 1);   //$BI8=`=PNO$r%Q%$%W$K(B
    if( execvp(args[0],args) < 0 ){  //ssh (mipconfig) 
      perror("execvp");
      exit(1);
    }
    close(fd[0]);    //$B;H$$=*$C$?$i%/%m!<%:(B
  }else{         // parent 
    cpid = wait(&status);  //child$B$,;`$L$N$rBT$D(B
    close(fd[0]);         //$B$$$i$J$$J}$r%/%m!<%:(B    
    if(read(fd[1],info,MAX)<0){
      perror("read");
      exit(0);
    }
    close(fd[1]);    //$B;H$$=*$C$?$i%/%m!<%:(B
  }
}

/* BUL @ MR $B$r>C$9(B  */   // not garantee
void del_BUL(int target){
  char line[ARGS];
  sprintf(line,"ssh -6 tu-ka@%s mipconfig -c bu -m del -a %s"
	  ,mr[target].host_name, mr[target].home );
  printf("%s\n", line);   
  //  ExecCommand(line);
} 

/* BC @ HA $B$r>C$9(B  */   // not garantee
void del_BC(int target){
  char line[ARGS];
  sprintf(line,"ssh -6 tu-ka@%s mipconfig -c bc -m del -a %s"
	  ,mr[target].host_name, mr[target].home);
  printf("%s\n",line);
  //  ExecCommand(line);
} 

/* rtsol $B$r<B9T$9$k(B*/  // not garantee
void rtsol_comand(int target ,char *if_name){
  char line[MAX];

  sprintf(line,"ssh -6 tu-ka@%s rtsol %s",mr[target].host_name, if_name);
  printf("%s\n", line);    //****
  //ExecCommand(line);
}

/* start HA*/
void start_HA(int target, char *if_name){
  char line[MAX];
  
  sprintf(line,"ssh -6 tu-ka@%s mipconfig -c ha -m add -i %s"
	  ,ha[target].host_name, if_name);
  printf("%s\n", line);    //****
  //ExecCommand(line);
  
}

/* Stop HA */
void stop_HA(int target, char *if_name){
  char line[MAX];
  
  sprintf(line,"ssh -6 tu-ka@%s mipconfig -c ha -m del -i %s"
	  ,mr[target].host_name, if_name);
  printf("%s\n", line);    //****
  //ExecCommand(line);
}


/* Add network intarface*/
void add_interface(int target,char *if_name, int primary){
  char line[MAX];
  if(primary == 0){                        //primary$B$8$c$J$$;~(B
    sprintf(line,"ssh -6 tu-ka@%s mipconfig -c if -m add -i %s"
	    ,mr[target].host_name, if_name);
  }else if(primary ==1 ){                  //primary$B$@$C$?$i(B
    sprintf(line,"ssh -6 tu-ka@%s mipconfig -c if -m add -p -i %s"
	    ,mr[target].host_name, if_name);
  }
  printf("%s\n", line);    //****
  //ExecCommand(line); 
}

/* Cange network intarface*/
void change_interface(int target, char *if_name, int primary){
  char line[MAX];
  if(primary == 0){                        //primary$B$8$c$J$$;~(B
    sprintf(line,"ssh -6 tu-ka@%s mipconfig -c if -m change -i %s"
	    ,mr[target].host_name, if_name);
  }else if(primary ==1 ){                  //primary$B$@$C$?$i(B
    sprintf(line,"ssh -6 tu-ka@%s mipconfig -c if -m change -p -i %s"
	    ,mr[target].host_name, if_name);
  }
  printf("%s\n", line);    //****
  //ExecCommand(line); 
}

/* Delete network intarface*/
void del_interface(int target, char *if_name){
  char line[MAX];
  
  sprintf(line,"ssh -6 tu-ka@%s mipconfig -c ha -m del -i %s"
	  ,ha[target].host_name, if_name);
  printf("%s\n", line);    //****
  //ExecCommand(line);  
}



/*MR$B$N>pJs$r$H$j$K9T$/(B
 CoA$B$KJQ2=$,$J$+$C$?$i(B 0 ,$BJQ2=$7$F$$$?$i(B1$B$rJV$9(B*/
int getInfoMR(int target){
  /* info: infomation from HA   */
  char line[ARGS];
  char old_coa[ADDRESS];
  
  //$B>pJs$r$H$j$K9T$/A0$H$"$H$GJQ$o$C$?$+$r8+$k$?$aA0$N$b$N$rJ]B8$9$k(B
  strcpy(old_coa, mr[target].coa);
  
  // sprintf(line, "ssh tu-ka@%s mipconfig -c bu -m get",mr[target].host_name);
  sprintf(line,"cat data/mipconfigMR%d",target%10);   //***   
  //  sprintf(line, "ssh -6 tu-ka@%s mipconfig -c bu -m get",ha[target].coa);
  
  ExecCommand(line);//$B%3%^%s%I$r<B9T(B ($B=PNO(B -> info)
  devideInfoMR(target);
  
  if( strcmp(old_coa, mr[target].coa) ==0 ){  //$BJQ2=$J$7(B
    return 0;
  }else{                //$BJQ2=$"$j(B 
    return 1;
  }
}



/*HA$B$N>pJs$r$H$j$K9T$/(B*/
void getInfoHA(int target){
  /* info: infomation from HA   */
  char line[ARGS];

  //sprintf(line, "ssh tu-ka@%s mipconfig -c bc -m get", ha[target].host_name);
  
  sprintf(line,"cat data/mipconfigHA%d",target%10);   //***   

  ExecCommand(line);

  devideInfoHA(target);
}

/* HA $B$H(B MR $B$NEPO?(B */
void registration(){
  char line[ARGS];
  
  sprintf(line,"cat hosts"); 
  ExecCommand(line);
  read_hosts();
}
